// Form1.h

#pragma once

#include "InstanceSwitchMethod.h"

namespace BringUpTest {

  using namespace System;
  using namespace System::ComponentModel;
  using namespace System::Collections;
  using namespace System::Windows::Forms;
  using namespace System::Data;
  using namespace System::Drawing;
  using namespace System::Threading;
  using namespace System::Diagnostics;
  using namespace Microsoft::Win32;

  /// <summary>
  /// Zusammenfassung fr Form1
  /// </summary>
  public ref class Form1 : public System::Windows::Forms::Form
  {
  public:
    Form1(void) : m_ism(InstanceSwitchMethod::Classic)
    {
      InitializeComponent();
      //
      //TODO: Konstruktorcode hier hinzufgen.
      //

#ifdef _DEBUG
      Text += " (debug)";
#endif

      m_strMessageEchoSignalEvent = "{0EB4D48D-1134-4d42-A43C-9296FCF78AFC}";
#ifdef _DEBUG
      m_strMessageEchoSignalEvent += "_(debug)";
#endif
    }

  protected:
    /// <summary>
    /// Verwendete Ressourcen bereinigen.
    /// </summary>
    ~Form1()
    {
      RemoveRegistryEntry();
      if (m_evtMessageEchoSignal) {
        m_evtMessageEchoSignal->Close();
        delete m_evtMessageEchoSignal;
      }
      m_mtxInstance->Close();
      delete m_mtxInstance;

      if (components)
      {
        delete components;
      }
    }

  private:
    InstanceSwitchMethod m_ism;
    Mutex ^m_mtxInstance;
    EventWaitHandle ^m_evtMessageEchoSignal;
    String ^m_strMessageEchoSignalEvent;
    bool m_bRegistryEntryCreated;  // Means we have created the registry entry ourselves, not another instance

  private: System::Windows::Forms::Label^  label1;
  protected: 
  private: System::Windows::Forms::Label^  label2;
  private: System::Windows::Forms::GroupBox^  groupBox1;
  private: System::Windows::Forms::RadioButton^  rbAlt;
  private: System::Windows::Forms::RadioButton^  rbClassic;
  private: System::Windows::Forms::RadioButton^  rbMessageEcho;
  private: System::Windows::Forms::Timer^  tmrMessageEchoTimeout;
  private: System::Windows::Forms::RadioButton^  rbDepositedHandle;
  private: System::Windows::Forms::RadioButton^  rbFakeHotkey;

  private: System::ComponentModel::IContainer^  components;




  private:
    /// <summary>
    /// Erforderliche Designervariable.
    /// </summary>


#pragma region Windows Form Designer generated code
    /// <summary>
    /// Erforderliche Methode fr die Designeruntersttzung.
    /// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
    /// </summary>
    void InitializeComponent(void)
    {
      this->components = (gcnew System::ComponentModel::Container());
      this->label1 = (gcnew System::Windows::Forms::Label());
      this->label2 = (gcnew System::Windows::Forms::Label());
      this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
      this->rbFakeHotkey = (gcnew System::Windows::Forms::RadioButton());
      this->rbDepositedHandle = (gcnew System::Windows::Forms::RadioButton());
      this->rbMessageEcho = (gcnew System::Windows::Forms::RadioButton());
      this->rbAlt = (gcnew System::Windows::Forms::RadioButton());
      this->rbClassic = (gcnew System::Windows::Forms::RadioButton());
      this->tmrMessageEchoTimeout = (gcnew System::Windows::Forms::Timer(this->components));
      this->groupBox1->SuspendLayout();
      this->SuspendLayout();
      // 
      // label1
      // 
      this->label1->AutoSize = true;
      this->label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
        static_cast<System::Byte>(0)));
      this->label1->Location = System::Drawing::Point(9, 11);
      this->label1->Name = L"label1";
      this->label1->Size = System::Drawing::Size(182, 13);
      this->label1->TabIndex = 0;
      this->label1->Text = L"Bring me back up by launching";
      // 
      // label2
      // 
      this->label2->AutoSize = true;
      this->label2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
        static_cast<System::Byte>(0)));
      this->label2->Location = System::Drawing::Point(9, 24);
      this->label2->Name = L"label2";
      this->label2->Size = System::Drawing::Size(149, 13);
      this->label2->TabIndex = 1;
      this->label2->Text = L"another instance of me...";
      // 
      // groupBox1
      // 
      this->groupBox1->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
        | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
      this->groupBox1->Controls->Add(this->rbFakeHotkey);
      this->groupBox1->Controls->Add(this->rbDepositedHandle);
      this->groupBox1->Controls->Add(this->rbMessageEcho);
      this->groupBox1->Controls->Add(this->rbAlt);
      this->groupBox1->Controls->Add(this->rbClassic);
      this->groupBox1->Location = System::Drawing::Point(11, 40);
      this->groupBox1->Name = L"groupBox1";
      this->groupBox1->Size = System::Drawing::Size(178, 148);
      this->groupBox1->TabIndex = 2;
      this->groupBox1->TabStop = false;
      this->groupBox1->Text = L"Primary instance activation method";
      // 
      // rbFakeHotkey
      // 
      this->rbFakeHotkey->AutoSize = true;
      this->rbFakeHotkey->Location = System::Drawing::Point(6, 122);
      this->rbFakeHotkey->Name = L"rbFakeHotkey";
      this->rbFakeHotkey->Size = System::Drawing::Size(86, 17);
      this->rbFakeHotkey->TabIndex = 4;
      this->rbFakeHotkey->TabStop = true;
      this->rbFakeHotkey->Text = L"Fake &Hotkey";
      this->rbFakeHotkey->UseVisualStyleBackColor = true;
      this->rbFakeHotkey->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbFakeHotkey_CheckedChanged);
      // 
      // rbDepositedHandle
      // 
      this->rbDepositedHandle->AutoSize = true;
      this->rbDepositedHandle->Location = System::Drawing::Point(6, 99);
      this->rbDepositedHandle->Name = L"rbDepositedHandle";
      this->rbDepositedHandle->Size = System::Drawing::Size(110, 17);
      this->rbDepositedHandle->TabIndex = 3;
      this->rbDepositedHandle->TabStop = true;
      this->rbDepositedHandle->Text = L"&Deposited Handle";
      this->rbDepositedHandle->UseVisualStyleBackColor = true;
      this->rbDepositedHandle->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbDepositedHandle_CheckedChanged);
      // 
      // rbMessageEcho
      // 
      this->rbMessageEcho->AutoSize = true;
      this->rbMessageEcho->Location = System::Drawing::Point(6, 76);
      this->rbMessageEcho->Name = L"rbMessageEcho";
      this->rbMessageEcho->Size = System::Drawing::Size(96, 17);
      this->rbMessageEcho->TabIndex = 2;
      this->rbMessageEcho->TabStop = true;
      this->rbMessageEcho->Text = L"Message &Echo";
      this->rbMessageEcho->UseVisualStyleBackColor = true;
      this->rbMessageEcho->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbMessageEcho_CheckedChanged);
      // 
      // rbAlt
      // 
      this->rbAlt->AutoSize = true;
      this->rbAlt->Location = System::Drawing::Point(6, 53);
      this->rbAlt->Name = L"rbAlt";
      this->rbAlt->Size = System::Drawing::Size(75, 17);
      this->rbAlt->TabIndex = 1;
      this->rbAlt->TabStop = true;
      this->rbAlt->Text = L"&Alternative";
      this->rbAlt->UseVisualStyleBackColor = true;
      this->rbAlt->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbAlt_CheckedChanged);
      // 
      // rbClassic
      // 
      this->rbClassic->AutoSize = true;
      this->rbClassic->Location = System::Drawing::Point(6, 30);
      this->rbClassic->Name = L"rbClassic";
      this->rbClassic->Size = System::Drawing::Size(58, 17);
      this->rbClassic->TabIndex = 0;
      this->rbClassic->TabStop = true;
      this->rbClassic->Text = L"&Classic";
      this->rbClassic->UseVisualStyleBackColor = true;
      this->rbClassic->CheckedChanged += gcnew System::EventHandler(this, &Form1::rbClassic_CheckedChanged);
      // 
      // tmrMessageEchoTimeout
      // 
      this->tmrMessageEchoTimeout->Interval = 10000;
      this->tmrMessageEchoTimeout->Tick += gcnew System::EventHandler(this, &Form1::tmrMessageEchoTimeout_Tick);
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(201, 200);
      this->Controls->Add(this->groupBox1);
      this->Controls->Add(this->label2);
      this->Controls->Add(this->label1);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"Bring me up!";
      this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
      this->groupBox1->ResumeLayout(false);
      this->groupBox1->PerformLayout();
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion

  // Base class method overrides:

  protected:
    virtual void WndProc(Message %msg) override;

  // Other member functions:

  private:
    void BringMeUp();
    void MessageEchoAdvertiseHandler(IntPtr ipHwndNonPrimary);
    void MessageEchoAdvertisementResponseHandler(IntPtr ipHwndPrimary);
    void RemoveRegistryEntry();

  // Event handlers:

  private:
    System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e);
    System::Void tmrMessageEchoTimeout_Tick(System::Object^  sender, System::EventArgs^  e);
    System::Void rbClassic_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
    System::Void rbAlt_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
    System::Void rbMessageEcho_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
    System::Void rbDepositedHandle_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
    System::Void rbFakeHotkey_CheckedChanged(System::Object^  sender, System::EventArgs^  e);
};
}
